/* Blink with timer Turn an LED on for 1 swc and off for 1 sec repeatedly  */

#define TIMER_BLINK TIM4

volatile uint16_t count = 0;

/* Handler for Timer */
static stimer_t TimHandle;

/**
@brief blink callback. Call by a timer interrupt.
@param htim: pointer to stimer_t
@retval None
*/

static void blink(stimer_t *htim) {
    UNUSED(htim);
    if (count++ == 100)
    {
        count =0;
        digitalWrite(LED_BUILTIN, !digitalRead(LED_BUILTIN));
    }
}

// the setup function runs once when you press reset or power the board

void setup()
{
    // initialise digital pin LED_BUILTIN as an output);
    pinMode(LED_BUILTIN, OUTPUT);
    /* Set TIMx instance.  */
    TimHandle.timer = TIMER_BLINK;
    /* Timer set to 10ms */
    TimerHandleInit(&TimHandle, 10000 - 1, ((uint32_t)(getTimerClkFreq(TIMER_BLINK) / (1000000)) - 1));
    attachIntHandle(&TimHandle, blink);
}

// the loop function runs over and over again forever
void loop()
{
    // do nothing
}
